require 'fileutils'

module Pod
  class Command
    # This is an example of a cocoapods plugin adding a top-level subcommand
    # to the 'pod' command.
    #
    # You can also create subcommands of existing or new commands. Say you
    # wanted to add a subcommand to `list` to show newly deprecated pods,
    # (e.g. `pod list deprecated`), there are a few things that would need
    # to change.
    #
    # - move this file to `lib/pod/command/list/deprecated.rb` and update
    #   the class to exist in the the Pod::Command::List namespace
    # - change this class to extend from `List` instead of `Command`. This
    #   tells the plugin system that it is a subcommand of `list`.
    # - edit `lib/cocoapods_plugins.rb` to require this file
    class Framework < Command
      self.abstract_command = true
      self.summary = 'Manipulate the Framework Project.'

      self.description = <<-DESC
        Manipulate the Framework Project. such as Create.
      DESC

      class Create < Framework
        self.summary = 'Generate a Framwork Project.'

        self.description = <<-DESC
          Generate a Framwork Project.
        DESC

        self.arguments = [
          CLAide::Argument.new('PROJECT_NAME', false),
        ]

        def initialize(argv)
          @name = argv.shift_argument
          super
        end

        def validate!
          super
          help! 'A project name is required.' unless @name
        end

        def run
          `git clone --depth 1 git@gitlab.alibaba-inc.com:AliMusic-Mobile/FrameworkTemplate.git`
          Dir.chdir("FrameworkTemplate")
          current_directory = Dir.pwd
          `#{current_directory}/MakeProject.sh #{@name}`
          `mv #{current_directory}/#{@name} #{current_directory}/../#{@name}`

          FileUtils.rm_rf('./../FrameworkTemplate')
        end
      end
    end
  end
end
